﻿-- ** Meliandah / Animal Species / 20.02.2019  ** --
 
animalSpecies = {}
animalSpecies.blackHorseRidingTimeRatio = 5.0;

function animalSpecies:debug(message)
  print(('### Animal Species : %s'):format(message));
end;

function animalSpecies:rpad(str, len, char)
    if len == nil then len = 15 end
    if char == nil then char = ' ' end
    return animalSpecies:ternary(str ~= nil, string.rep(char, len - #tostring(str)) .. tostring(str), string.rep(char, len));
end
function animalSpecies:lpad(str, len, char)
    if len == nil then len = 15 end
    if char == nil then char = ' ' end
    return animalSpecies:ternary(str ~= nil, tostring(str) .. string.rep(char, len - #tostring(str)), string.rep(char, len));
end
function animalSpecies:ternary(cond, T, F)
    if cond then return T else return F end
end

function animalSpecies:printAnimalTypes()
  --animalSpecies:debug('printing AnimalManager');
  --DebugUtil.printTableRecursively(g_currentMission.inGameMenu.pageAnimals.animalManager, ".", 0, 5);
  --animalSpecies:debug('printing animalTypes');
  --DebugUtil.printTableRecursively(g_currentMission.inGameMenu.pageAnimals.animalManager.animals, ".", 0, 10);

  animalSpecies:debug(('%s | %s | %s | %s | %s | %s | %s | %s | %s | %s')
    :format(animalSpecies:rpad('type'), animalSpecies:rpad('subTypeName', 25), animalSpecies:rpad('strawPerDay'), animalSpecies:rpad('waterPerDay'),  animalSpecies:rpad('foodPerDay'), 
            animalSpecies:rpad('manurePerDay'), animalSpecies:rpad('liquidManurePerDay'), animalSpecies:rpad('milkPerDay'), animalSpecies:rpad('palletsPerDay'), animalSpecies:rpad('birthRatePerDay', 20)));

  for k,v in pairs(g_currentMission.inGameMenu.pageAnimals.animalManager.animals) do
      --DebugUtil.printTableRecursively(v, ".", 0, 10);
	  for sk,sv in pairs(v.subTypes) do
      animalSpecies:debug(('%s | %s | %s | %s | %s | %s | %s | %s | %s | %s')
        :format(animalSpecies:rpad(v.class), animalSpecies:rpad(sv.subTypeName, 25), animalSpecies:rpad(sv.input.strawPerDay), animalSpecies:rpad(sv.input.waterPerDay),  animalSpecies:rpad(sv.input.foodPerDay), 
                animalSpecies:rpad(sv.output.manurePerDay), animalSpecies:rpad(sv.output.liquidManurePerDay), animalSpecies:rpad(sv.output.milkPerDay), animalSpecies:rpad(sv.output.palletsPerDay), animalSpecies:rpad(sv.breeding.birthRatePerDay, 20)));
	end;
  end;
end;

function animalSpecies:updateAnimalTypes()

  for k,v in pairs(g_currentMission.inGameMenu.pageAnimals.animalManager.animals) do
      --DebugUtil.printTableRecursively(v, ".", 0, 10);
	  for sk,sv in pairs(v.subTypes) do

      -- COWS ------------------------------------------------------------
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BROWN' then
        sv.storeInfo.shopItemName = 'Classic white cow';
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BROWN_WHITE' then
                sv.output.milkPerDay = sv.output.milkPerDay * 0.75;
                sv.output.manurePerDay = sv.output.manurePerDay * 1.5;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 1.5;
                sv.input.foodPerDay = sv.input.foodPerDay * 0.75;
                sv.input.waterPerDay = sv.input.waterPerDay * 0.75;                
                sv.storeInfo.buyPrice = 2250.0;
                sv.storeInfo.sellPrice = 1250.0;
                sv.storeInfo.transportPrice = 250.0;
                sv.storeInfo.shopItemName = 'Brownie food-, manure+, milk-';
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.25;
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BLACK' then
                sv.output.milkPerDay = sv.output.milkPerDay * 1.5;
                sv.output.manurePerDay = sv.output.manurePerDay * 0.9;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 0.9;
                sv.input.foodPerDay = sv.input.foodPerDay * 1.25;
                sv.input.waterPerDay = sv.input.waterPerDay * 1.25;                
                sv.storeInfo.buyPrice = 3700.0;
                sv.storeInfo.sellPrice = 1450.0;
                sv.storeInfo.transportPrice = 650.0;
                sv.storeInfo.shopItemName = 'Blacky food+, manure-, milk+';
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.25;          
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BLACK_WHITE' then
                sv.output.milkPerDay = sv.output.milkPerDay * 2.50;
                sv.output.manurePerDay = sv.output.manurePerDay * 2.5;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 2.5;
                sv.input.foodPerDay = sv.input.foodPerDay * 2.5;
                sv.input.waterPerDay = sv.input.waterPerDay * 2.5;                
                sv.storeInfo.buyPrice = 6700.0;
                sv.storeInfo.sellPrice = 3500.0;
                sv.storeInfo.transportPrice = 1400.0;
                sv.storeInfo.shopItemName = 'BlackWhitie - x2.5';
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.75;       
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BRAHMAN_BROWN' then
                sv.output.milkPerDay = sv.output.milkPerDay * 5.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 6.25
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 4.5;
                sv.input.foodPerDay = sv.input.foodPerDay * 5.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 5.0;                
                sv.storeInfo.buyPrice = 12050.0;
                sv.storeInfo.sellPrice = 9500.0;
                sv.storeInfo.transportPrice = 2700.0;
                sv.storeInfo.shopItemName = 'BraBrownie-x5, more manure';
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 2.0;    
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BRAHMAN_WHITE' then
                sv.output.milkPerDay = sv.output.milkPerDay * 5.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 4.5;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 6.25;
                sv.input.foodPerDay = sv.input.foodPerDay * 5.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 5.0;                
                sv.storeInfo.buyPrice = 12050.0;
                sv.storeInfo.sellPrice = 9500.0;
                sv.storeInfo.transportPrice = 2700.0;
                sv.storeInfo.shopItemName = 'BraWhitie-x5, more liquid manure';
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 2.0;
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BRAHMAN_LIGHT_BROWN' then
                sv.output.milkPerDay = sv.output.milkPerDay * 10.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 10.0;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 10.0;
                sv.input.foodPerDay = sv.input.foodPerDay * 10.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 10.0;                
                sv.storeInfo.buyPrice = 34400.0;
                sv.storeInfo.sellPrice = 25000.0;
                sv.storeInfo.transportPrice = 50000.0;
                sv.storeInfo.shopItemName = 'BraLight, Need transport, x10';
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.5;
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BRAHMAN_GREY' then
                sv.output.milkPerDay = sv.output.milkPerDay * 100.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 100.0;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 100.0;
                sv.input.foodPerDay = sv.input.foodPerDay * 100.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 100.0; 
                sv.storeInfo.shopItemName = "Bra-Grey! For experienced farmer! x100";               
                sv.storeInfo.buyPrice = 666666.0;
                sv.storeInfo.transportPrice = 666666666.0;
                sv.storeInfo.sellPrice = 6.0;
                sv.breeding.birthRatePerDay = 0;
      end;
      
      -- HORSES ---------------------------------------------------------
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_BROWN' then
                sv.storeInfo.shopItemName = "Classic Horse";                
      end;
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_DARK_BROWN' then
                sv.input.foodPerDay = sv.input.foodPerDay * 2.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 2.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 2.0;
                sv.storeInfo.buyPrice = 10000.0;
                sv.storeInfo.transportPrice = 5000.0;
                sv.storeInfo.sellPrice = 125000.0;                
      end;
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_BROWN_WHITE' then
                sv.input.foodPerDay = sv.input.foodPerDay * 5.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 5.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 5.0;
                sv.storeInfo.buyPrice = 29450.0;
                sv.storeInfo.transportPrice = 19000.0;
                sv.storeInfo.sellPrice = 247000.0;                
      end;
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_GREY' then
                sv.input.foodPerDay = sv.input.foodPerDay * 10.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 10.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 10.0;
                sv.storeInfo.buyPrice = 59000.0;
                sv.storeInfo.transportPrice = 37000.0;
                sv.storeInfo.sellPrice = 490000.0;                
      end;
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_LIGHT_BROWN' then
                sv.input.foodPerDay = sv.input.foodPerDay * 15.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 15.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 15.0;
                sv.storeInfo.buyPrice = 79000.0;
                sv.storeInfo.transportPrice = 49000.0;
                sv.storeInfo.sellPrice = 790000.0;                
      end;
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_BEIGE' then
                sv.input.foodPerDay = sv.input.foodPerDay * 25.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 25.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 25.0;
                sv.storeInfo.buyPrice = 139000.0;
                sv.storeInfo.transportPrice = 75000.0;
                sv.storeInfo.sellPrice = 1350000.0;
                sv.storeInfo.shopItemName = "Beigie Horse! Not easy to mount!";
      end;
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_RED_BROWN' then
                sv.input.foodPerDay = sv.input.foodPerDay * 50.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 50.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 50.0;
                sv.storeInfo.buyPrice = 299000.0;
                sv.storeInfo.transportPrice = 199000.0;
                sv.storeInfo.sellPrice = 2400000.0;
                sv.storeInfo.shopItemName = "Red Brownie! He don't like monitors!";                
      end;
      
      if sv.fillTypeDesc.name == 'HORSE_TYPE_BLACK' then
                sv.input.foodPerDay = sv.input.foodPerDay * 200.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 200.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 100.0;
                sv.storeInfo.buyPrice = 950000.0;
                sv.storeInfo.transportPrice = 100000000.0;
                sv.storeInfo.sellPrice = 10000000.0;                
                sv.storeInfo.shopItemName = "BigBlack Horse! Hard to grow up!";                
      end;
      
      -- SHEEP ---------------------------------------------------------
      
      if sv.fillTypeDesc.name == 'SHEEP_TYPE_WHITE' then                                
                sv.storeInfo.shopItemName = "Whitie , Classic Sheep";        
      end;
      
      if sv.fillTypeDesc.name == 'SHEEP_TYPE_BROWN' then
                sv.input.foodPerDay = sv.input.foodPerDay * 2.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 2.0;
                sv.output.palletsPerDay = sv.output.palletsPerDay * 2.0;               
                sv.storeInfo.buyPrice = 2950.0;
                sv.storeInfo.transportPrice = 475.0;
                sv.storeInfo.sellPrice = 1500.0;                
                sv.storeInfo.shopItemName = "Double Brownie wool - x2";
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.25;
      end;
      
      if sv.fillTypeDesc.name == 'SHEEP_TYPE_BLACK_WHITE' then
                sv.input.foodPerDay = sv.input.foodPerDay * 5.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 5.0;
                sv.output.palletsPerDay = sv.output.palletsPerDay * 5.0;            
                sv.storeInfo.buyPrice = 9500.0;
                sv.storeInfo.transportPrice = 4475.0;
                sv.storeInfo.sellPrice = 3500.0;                
                sv.storeInfo.shopItemName = "Whitie - x5";
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.75;
      end;
      
      if sv.fillTypeDesc.name == 'SHEEP_TYPE_BLACK' then
                sv.input.foodPerDay = sv.input.foodPerDay * 100.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 100.0;
                sv.output.palletsPerDay = sv.output.palletsPerDay * 100.0;              
                sv.storeInfo.buyPrice = 234500.0;
                sv.storeInfo.transportPrice = 135000.0;
                sv.storeInfo.sellPrice = 125000.0;                
                sv.storeInfo.shopItemName = "Blackool, dark wool who always grown-x10";
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.5;
      end;
      
      
      -- CHICKEN ---------------------------------------------------------
      
      if sv.fillTypeDesc.name == 'CHICKEN_TYPE_WHITE' then                                
                sv.input.foodPerDay = sv.input.foodPerDay * 2.0;
                sv.output.palletsPerDay = sv.output.palletsPerDay * 2.0;               
                sv.storeInfo.buyPrice = 110.0;
                sv.storeInfo.transportPrice = 20.0;
                sv.storeInfo.sellPrice = 50.0;                
                sv.storeInfo.shopItemName = "Whitie - x2";
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.25;  
      end;
      
      if sv.fillTypeDesc.name == 'CHICKEN_TYPE_BLACK' then
                sv.input.foodPerDay = sv.input.foodPerDay * 5.0;
                sv.output.palletsPerDay = sv.output.palletsPerDay * 5.0;               
                sv.storeInfo.buyPrice = 290.0;
                sv.storeInfo.transportPrice = 140.0;
                sv.storeInfo.sellPrice = 120.0;                
                sv.storeInfo.shopItemName = "Blackie - x5";
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.25;
      end;
      
      if sv.fillTypeDesc.name == 'CHICKEN_TYPE_BROWN' then
                sv.input.foodPerDay = sv.input.foodPerDay * 10.0;
                sv.output.palletsPerDay = sv.output.palletsPerDay * 10.0;               
                sv.storeInfo.buyPrice = 590.0;
                sv.storeInfo.transportPrice = 340.0;
                sv.storeInfo.sellPrice = 420.0;                
                sv.storeInfo.shopItemName = "Brownie - x10";
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.75;
      end;
      
      if sv.fillTypeDesc.name == 'CHICKEN_TYPE_ROOSTER' then
                sv.input.foodPerDay = sv.input.foodPerDay * 100.00;                
                sv.output.palletsPerDay = 0.1 * 100.0;              
                sv.storeInfo.buyPrice = 5800.0;
                sv.storeInfo.transportPrice = 3500.0;
                sv.storeInfo.sellPrice = 4500.0;                
                sv.storeInfo.shopItemName = "Rooster Eggs ! - x100";
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.25;
      end;
      
      -- PIG ---------------------------------------------------------
      
      if sv.fillTypeDesc.name == 'PIG_TYPE_RED' then                                
                sv.storeInfo.shopItemName = "Red guy , Classic Pig";        
      end;
      
      if sv.fillTypeDesc.name == 'PIG_TYPE_WHITE' then
                sv.input.foodPerDay = sv.input.foodPerDay * 2.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 2.0;                    
                sv.output.manurePerDay = sv.output.manurePerDay * 4.50;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 5.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 2.0;        
                sv.storeInfo.buyPrice = 2850.0;
                sv.storeInfo.transportPrice = 400.0;
                sv.storeInfo.sellPrice = 1400.0;                
                sv.storeInfo.shopItemName = "Whitie - x2";
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.25;    
      end;
      
      if sv.fillTypeDesc.name == 'PIG_TYPE_BLACK_WHITE' then
                sv.input.foodPerDay = sv.input.foodPerDay * 5.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 5.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 10.00;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 12.00;
                sv.input.strawPerDay = sv.input.strawPerDay * 5.0;         
                sv.storeInfo.buyPrice = 9400.0;
                sv.storeInfo.transportPrice = 2300.0;
                sv.storeInfo.sellPrice = 7500.0;                
                sv.storeInfo.shopItemName = "HalfWhitie - x5";
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 0.75;
      end;
      
      if sv.fillTypeDesc.name == 'PIG_TYPE_BLACK' then
                sv.input.foodPerDay = sv.input.foodPerDay * 100.0;
                sv.input.waterPerDay = sv.input.waterPerDay * 100.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 200.00;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 200.00;
                sv.input.strawPerDay = sv.input.strawPerDay * 100.0;             
                sv.storeInfo.buyPrice = 198000.0;
                sv.storeInfo.transportPrice = 244000.0;
                sv.storeInfo.sellPrice = 145000.0;                
                sv.storeInfo.shopItemName = "Blacky ! For experienced farmers-x100";
                sv.breeding.birthRatePerDay = 0.25;
      end;
    end;
  end;
end;

function animalSpecies:loadMap(name)    
    animalSpecies:updateAnimalTypes();
    animalSpecies:printAnimalTypes();
end;

function animalSpecies:keyEvent(unicode, sym, modifier, isDown)
end;

function animalSpecies:update(dt)
end;

function animalSpecies:draw()
end;

function animalSpecies:deleteMap()
end;

function animalSpecies:mouseEvent(posX, posY, isDown, isUp, button)
end;

addModEventListener(animalSpecies);